/*
    PlayingStyle.h
  
    Copyright (C) 1998, 1999 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef PlayingStyle_H
#define PlayingStyle_H

namespace PlayingStyle
{
  enum PlayingStyle
  {
    //Ͽ˱դ롣
    NORMAL,
    NORMAL_REVERSE,
    
    SHUFFLE,
    RANDOM,
    
    FILENAME_ORDER,
    FILENAME_REVERSE_ORDER,
    
    TITLE_ORDER,
    TITLE_REVERSE_ORDER,
    
    FILESIZE_ORDER,
    FILESIZE_REVERSE_ORDER,
    
    TIME_ORDER,
    TIME_REVERSE_ORDER,
    
    //album fileɤ߹ǤϿ˱դ롣
    ALBUM,
    ALBUM_REVERSE,
    //needs more?
  };

  enum LoopStyle
  {
    //Ǹζʤ˹Ԥäǽζʤ롣
    LOOP,
    //ǸޤǹԤä顢Ǹζʤ򷫤֤դ롣
    STOP_AT_END,
    //ʤ򷫤֤դ롣
    REPEAT,
  };
  
  enum PlayingMode
  {
    CONTINUOUS_PLAY,//ʱդä³Ƽζʤդ롣
    STOPS_PER_SONG,//ʱդߤ롣
  };

  extern const PlayingStyle DEFAULT_PLAYING_STYLE;
  extern const LoopStyle DEFAULT_LOOP_STYLE;
  extern const PlayingMode DEFAULT_PLAYING_MODE;
};

#endif //PlayingStyle_H
