/*
    RWLock.h
  
    Copyright (C) 1998, 1999 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef RWLock_H
#define RWLock_H

#include "CondVar.h"

class RWLock
{
private:
  Mutex lock;//monitor lock
  int readerNumber;//$BFI$_9~$_(Bthread$B$N?t(B
  int waitingWriters;//write lock$B$r;HMQ$HBT$C$F$$$k(Bthread$B$N?t(B
  bool doesWriting;//$B8=:_(Bwrite lock$B$7$F$$$k$+(B?
  CondVar readOK;
  CondVar writeOK;
public:
  RWLock ();
  ~RWLock ();
  void readLock ();
  void writeLock ();
  void unlock ();
};
#endif //RWLock_H
