/*
    Randome.cc
  
    Copyright (C) 1998, 1999 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "Random.h"

#ifndef HAVE_RAND_R
Mutex Random::mutex;
pthread_once_t Random::once = PTHREAD_ONCE_INIT;

using namespace std;

void Random::srand ()
{
  timeval timeVal;
  gettimeofday (&timeVal, NULL);
  std::srand (timeVal.tv_usec);;
}

#endif
