/*
    getCurrentWorkingDirectory.h
  
    Copyright (C) 1998, 1999 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef getCurrentWorkingDirectory_H
#define getCurrentWorkingDirectory_H

#include <unistd.h>
#include <string>

using namespace std;

//curreint working directory$B$r(B cwd$B$K@_Dj$7$FJV$9!#(B
//$BEvA3!"(Bcwd$B$NCf?H$OGK2u$5$l$k!#(B
void getCurrentWorkingDirectory (string& cwd)
{
  assert (cwd.length () == 0);

  char* buffer = NULL;
  char* absDirname = NULL;
  size_t size = 256;
  while (absDirname == NULL)
    {
      delete[] buffer;
      buffer = new char[size];
      absDirname = getcwd (buffer, size);
      size *= 2;
    }

  cwd = absDirname;
  delete[] buffer;
}
#endif //getCurrentWorkingDirectory_H
